/// <reference types="react" />
import { UseReducerContextSource } from './createUseReducerContext';
import { ReducerState, ReducerDispatch, CurrentState } from './createContext';
import { Subscription } from '../core/subscription';
export declare type UseGlobalState<T extends UseReducerContextSource> = {
    (): {
        [P in keyof T]: ReducerState<T[P]['reducer']>;
    };
    <SelectedState>(selector: (state: {
        [P in keyof T]: ReducerState<T[P]['reducer']>;
    }) => SelectedState): SelectedState;
};
export declare type UseGlobalDispatch<T extends UseReducerContextSource> = () => {
    [P in keyof T]: ReducerDispatch<T[P]['reducer']>;
};
export declare const createStore: <T extends UseReducerContextSource>(stateContext: import("react").Context<CurrentState<T>>, dispatchContext: import("react").Context<{ [P in keyof T]: ReducerDispatch<T[P]["reducer"]>; }>, subscription: Subscription<CurrentState<T>>) => {
    useGlobalState: UseGlobalState<CurrentState<T>>;
    useGlobalDispatch: UseGlobalDispatch<T>;
};
