import React from 'react';
import { UseStateContextSource } from './createUseStateContext';
import { Subscription } from '../core/subscription';
export declare type UseGlobalState<T extends UseStateContextSource> = {
    (): T;
    <SelectedState>(selector: (state: T) => SelectedState): SelectedState;
};
export declare type UseGlobalDispatch<T extends UseStateContextSource> = () => {
    [P in keyof T]: React.Dispatch<React.SetStateAction<T[P]>>;
};
export declare const createStore: <T extends UseStateContextSource>(stateContext: React.Context<T>, dispatchContext: React.Context<{ [P in keyof T]: React.Dispatch<React.SetStateAction<T[P]>>; }>, subscription: Subscription<T>) => {
    useGlobalState: {
        (): T;
        <SelectedState>(selector: (state: T) => SelectedState): SelectedState;
    };
    useGlobalDispatch: UseGlobalDispatch<T>;
};
